SYNO = window.SYNO || {};
SYNO.Encryption = SYNO.Encryption || {};

SYNO.Encryption.CipherKey = '';
SYNO.Encryption.RSAModulus = '';
SYNO.Encryption.CipherToken = '';
SYNO.Encryption.TimeBias = 0;

SYNO.isEmpty = function(value) {
	return value === null || value === undefined || value.length === 0 || value === "";
}

SYNO.urlEncode = function(obj) {
	var assignments = [];
	for (key in obj) {
		assignments.push(encodeURIComponent(key) + '=' + encodeURIComponent(obj[key]));
	}
	return assignments.join('&');
}

SYNO.Encryption.EncryptParam = function(params) {
	var engine, text, prepare = {}, result = {};

	if (!SYNO.Encryption.CipherKey || !SYNO.Encryption.RSAModulus || !SYNO.Encryption.CipherToken) {
		return params;
	}

	engine = new SYNO.Encryption.RSA();
	engine.setPublic(SYNO.Encryption.RSAModulus, '10001');

	$.extend(prepare, params);
	prepare[SYNO.Encryption.CipherToken] = Math.floor(+new Date()/1000) + SYNO.Encryption.TimeBias;

	text = engine.encrypt(SYNO.urlEncode(prepare));
	if (!text) {
		return params;
	}

	result[SYNO.Encryption.CipherKey] = SYNO.Encryption.Base64.hex2b64(text);
	return result;
};
